#include "MessPoint.h"

const MessPointXNameNr=1;
const MessPointYNameNr=173;
const MessPointTextNameNr=5;
char *MessPointXName[MessPointXNameNr]={{"Nr"}};
char *MessPointYName[MessPointYNameNr]={
  {"SigmaX"},{"SigmaY"},{"AmpX"},{"AmpY"},{"OpticalDensity"},
  {"NGauss"},{"NIntegral"},{"NIntOffset"},
  {"NROI0"},{"NROI1"},{"NROI2"},{"NROI3"},{"NROI4"},{"NROI5"},{"NROI6"},{"NROI7"},
  {"F0"},{"F1"},{"F2"},{"F3"},{"F4"},
  {"NOfROI0"},{"NOfROI1"},{"NOfROI2"},{"NOfROI3"},{"NOfROI4"},{"NOfROI5"},{"NOfROI6"},{"NOfROI7"},
  {"X0"},{"Y0"},
  {"GSlopeX"},{"GSlopeY"},{"GOffsetX"},{"GOffsetY"},{"XRMS"},
  {"YRMS"},{"n0Gauss"},{"RecapFluo"},{"N2D"},{"Tradial"},
  {"Taxial"},{"n0"},{"rho0"},{"Gamma"},{"X02D"},
  {"Y02D"},{"Offset2D"},{"SlopeX2D"},{"SlopeY2D"},{"Angle2D"},
  {"zCorr2D"},{"MOTFluorescence"},{"LoadingTime"},{"FermiL"},{"TempTOFaxial"},
  {"TempTOF"},{"TFermi_TCritic"},{"TBoson"},{"T_TF"},{"RF"},
  {"RM2_RF2"},{"Ecut"},{"eta"},{"NumberRatio"},{"NumberAtoms"},
  {"APDAverageRate"},{"APDOffsetRate"},{"Data0"},{"Data1"},{"Data2"},
  {"Data3"},{"Data4"},{"Data5"},{"Data6"},{"Data7"},
  {"Data8"},{"Data9"},{"Data10"},{"Data11"},{"Data12"},
  {"Data13"},{"Data14"},{"Data15"},{"Data16"},{"Data17"},
  {"Data18"},{"Data19"},{"Data20"},{"Data21"},{"Data22"},
  {"Data23"},{"Data24"},{"Data25"},{"Data26"},{"Data27"},
  {"Data28"},{"Data29"},{"Data30"},{"Data31"},{"Data32"},
  {"Data33"},{"Data34"},{"Data35"},{"Data36"},{"Data37"},
  {"Data38"},{"Data39"},{"Data40"},{"Data41"},{"Data42"},
  {"Data43"},{"Data44"},{"Data45"},{"Data46"},{"Data47"},
  {"Data48"},{"Data49"},{"ImageQuality"},{"FreeMem"},{"TrapType"},{"BarCurrent"},
  {"TransferCurrent"},{"MOTCurrent"},{"GxOrOffset"},{"GyOrGradient"},{"GzOrCurvature"},
  {"Li7f0"},{"Li7fend"},{"ProbeDetuning"},{"ExpansionTime"},{"Calibration"},
  {"EichX"},{"EichY"},{"NoisePictureMode"},{"NrProbeImages"},{"UseProbeLibrary"},
  {"Fluo"},{"FastKinetics"},{"FKSHeight"},{"FKSDirtyLines"},
  {"ProfilAverage"},{"SeveralPictures"},{"BiningX"},{"BiningY"},
  {"MaxFluo"},{"P1"},{"P2"},{"1DFitFunction"},{"2DFitFunction"},
  {"FitIter"},{"FitChange"},{"FitChiSq"},{"Camera"},{"PictureListPosition"},
  {"MainPicture"},
  {"Mass"},{"Wavelength"},{"Clebsch"},{"MagMoment"},{"Linewidth"},
  {"Pos1Xs"},{"Pos1Xe"},{"Pos1Ys"},{"Pos1Ye"},{"Pos2Xs"},
  {"Pos2Xe"},{"Pos2Ys"},{"Pos2Ye"},{"Color"},{"LineShift"},
  {"OffsetShift"},{"TimingError"}};

char *MessPointTextName[MessPointTextNameNr]={{"Filename"},{"Path"},{"Endstate"},{"AtomicName"},{"CameraDirection"}};

//*** CMessPoint ***
CMessPoint::CMessPoint():
  CMyPoint(MessPointXNameNr, MessPointYNameNr, MessPointTextNameNr,
         MessPointXName, MessPointYName, MessPointTextName) {
  SetX("Nr",0);
  SetY("SigmaX",1);
  SetY("SigmaY",1);
  SetY("AmpX",1);
  SetY("AmpY",1);
  SetY("OpticalDensity",1);
  SetY("NGauss",1E8);
  SetY("NIntegral",1E8);
  SetY("NIntOffset",0);
  SetY("NROI0",0);
  SetY("NROI1",0);
  SetY("NROI2",0);
  SetY("NROI3",0);
  SetY("NROI4",0);
  SetY("NROI5",0);
  SetY("NROI6",0);
  SetY("NROI7",0);
  SetY("NOfROI0",0);
  SetY("NOfROI1",0);
  SetY("NOfROI2",0);
  SetY("NOfROI3",0);
  SetY("NOfROI4",0);
  SetY("NOfROI5",0);
  SetY("NOfROI6",0);
  SetY("NOfROI7",0);
  SetY("F0",0);
  SetY("F1",0);
  SetY("F2",0);
  SetY("F3",0);
  SetY("F4",0);
  SetY("MOTFluorescence",1);
  SetY("LoadingTime",0);
  SetY("FermiL",1);
  SetY("TempTOF",0);
  SetY("TempTOFaxial",0);
  SetY("TFermi_TCritic",0);
  SetY("TBoson",0);
  SetY("T_TF",0);
  SetY("RF",0);
  SetY("RM2_RF2",0);
  SetY("Ecut",0);
  SetY("eta",0);
  SetY("NumberRatio",1);
  SetY("NumberAtoms",-1);
  SetY("APDAverageRate",-1);
  SetY("APDOffsetRate",-1);
  SetY("X0",0);
  SetY("Y0",0);
  SetY("GSlopeX",0);
  SetY("GSlopeY",0);
  SetY("GOffsetX",0);
  SetY("GOffsetY",0);
  SetY("XRMS",0);
  SetY("YRMS",0);
  SetY("n0Gauss",1E11);
  SetY("RecapFluo",1);
  SetY("N2D",1E8);
  SetY("Tradial",1);
  SetY("Taxial",1);
  SetY("n0",1E10);
  SetY("rho0",1E-6);
  SetY("Gamma",1);
  SetY("X02D",0);
  SetY("Y02D",0);
  SetY("Offset2D",0);
  SetY("SlopeX2D",0);
  SetY("SlopeY2D",0);
  SetY("Angle2D",-1.5);
  SetY("zCorr2D",1);
  SetY("TrapType",0);
  SetY("BarCurrent",750);
  SetY("TransferCurrent",500);
  SetY("MOTCurrent",5);
  SetY("GxOrOffset",12);
  SetY("GyOrGradient",1950);
  SetY("GzOrCurvature",650);
  SetY("ProbeDetuning",0);
  SetY("Calibration",1);
  SetY("EichX",0.01);
  SetY("EichY",0.01);
  SetY("NoisePictureMode",1);
  SetY("NrProbeImages",1);
  SetY("UseProbeLibrary",1);
  SetY("ImageQuality",0);
  SetY("FastKinetics",0);
  SetY("FKSHeight",256);
  SetY("FKSDirtyLines",256);
  SetY("ProfilAverage",1);
  SetY("SeveralPictures",0);
  SetY("BiningX",1);
  SetY("BiningY",1);
  SetY("MaxFluo",16384);
  SetY("P1",0);
  SetY("P2",1);
  SetY("1DFitFunction",0);
  SetY("2DFitFunction",0);
  SetY("Pos1Xs",0);
  SetY("Pos1Xe",1);
  SetY("Pos1Ys",0);
  SetY("Pos1Ye",1);
  SetY("Pos2Xs",0);
  SetY("Pos2Xe",1);
  SetY("Pos2Ys",0);
  SetY("Pos2Ye",1);
  SetY("Camera",0);
  SetY("PictureListPosition",0);
  SetY("FitIter",0);
  SetY("FitChange",0);
  SetY("FitChiSq",0);
  SetY("Color",0);
  SetY("LineShift",0);
  SetY("OffsetShift",1);
  SetY("TimingError",0);
  SetY("Fluo",0);
  SetY("Data0",0);
  SetY("Data1",0);
  SetY("Data2",0);
  SetY("Data3",0);
  SetY("Data4",0);
  SetY("Data5",0);
  SetY("Data6",0);
  SetY("Data7",0);
  SetY("Data8",0);
  SetY("Data9",0);
  SetY("Data10",0);
  SetY("Data11",0);
  SetY("Data12",0);
  SetY("Data13",0);
  SetY("Data14",0);
  SetY("Data15",0);
  SetY("Data16",0);
  SetY("Data17",0);
  SetY("Data18",0);
  SetY("Data19",0);
  SetY("Data20",0);
  SetY("Data21",0);
  SetY("Data22",0);
  SetY("Data23",0);
  SetY("Data24",0);
  SetY("Data25",0);
  SetY("Data26",0);
  SetY("Data27",0);
  SetY("Data28",0);
  SetY("Data29",0);
  SetY("Data30",0);
  SetY("Data31",0);
  SetY("Data32",0);
  SetY("Data33",0);
  SetY("Data34",0);
  SetY("Data35",0);
  SetY("Data36",0);
  SetY("Data37",0);
  SetY("Data38",0);
  SetY("Data39",0);
  SetY("Data40",0);
  SetY("Data41",0);
  SetY("Data42",0);
  SetY("Data43",0);
  SetY("Data44",0);
  SetY("Data45",0);
  SetY("Data46",0);
  SetY("Data47",0);
  SetY("Data48",0);
  SetY("Data49",0);
  SetY("FreeMem",0);
  SetY("Mass",6);
  SetY("Wavelength",671*10E-9);
  SetY("Clebsch",0.5);
  SetY("MagMoment",1);
  SetY("Linewidth",6E6);
  SetY("MainPicture",0);
  SetText("Filename","Noname.txt");
  SetText("Path","nothing");
  SetText("Endstate","nothing");
  SetText("AtomicName","6Li");
  SetText("CameraDirection","X");
}

CMessPoint::CMessPoint(ifstream *in,int &err) : CMyPoint(in,err) {};

CMessPoint::CMessPoint(CMyPoint *last) : CMyPoint(last) {};

