#include "rdsetup.h"
#include "setup.h"
#include "stdio.h"
#include "string.h"
#include "fstream.h"
#include <messageb.h>

/*
const RDSetupXNameNr=0;
const RDSetupYNameNr=4;
const RDSetupTextNameNr=2;
char *RDSetupXName[RDSetupXNameNr]={};
char *RDSetupYName[RDSetupYNameNr]={{"DataDisk"},{"HardwareAccess"},{"LiveDirectory"},{"LiveDisk"},{"LiveConnectTime"}};
char *RDSetupTextName[RDSetupTextNameNr]={{"DataDirectory"},{"MainDirectory"}};
*/

bool GetCommand(ifstream *in,char *command, char *data) {
  if (in->eof()) return false;
  char buf[200];
  in->getline(buf,200);
  if (buf[0]=='\\') return false;
  char *sep=strchr(buf,'=');
  if (!sep) return false;
  strncpy(command,buf,sep-buf);
  command[sep-buf]=0;
  sep++;
  strcpy(data,sep);
  return true;
}

/*void copy(char *&dest,const char *source) {
  if (dest) delete dest;
  dest=new char[strlen(source)+1];
  strcpy(dest,source);
} */

CRDSetup::CRDSetup() {
  strcpy(MainDirectory,InitMainDirectory);
  strcpy(DataDirectory,InitDataDirectory);
  HardwareAccess=InitHardwareAccess;
  LiveDirectory=InitLiveDirectory;
  LiveDisk=InitLiveDisk;
  DataDisk=InitDataDisk;
  LiveConnectTime=InitLiveConnectTime;

  ifstream *in=new ifstream(ConfigFileName);
  if (in->fail()) {
	 char buf[200];
	 sprintf(buf,"Could not open Configuration File %s",ConfigFileName);
    MessageBox(GetActiveWindow(),buf,"Error!",MB_OK);
    delete in;
	 return;
  }
  char command[200];
  char data[200];
  while (!in->eof()) {
    if (GetCommand(in,command,data)) {
       if (strcmp(command,"DataDirectory")==0) strcpy(DataDirectory,data);
       else if (strcmp(command,"MainDirectory")==0) strcpy(MainDirectory,data);
       else if (strcmp(command,"HardwareAccess")==0) HardwareAccess=data[0]=='1';
       else if (strcmp(command,"LiveDirectory")==0) LiveDirectory=data[0];
       else if (strcmp(command,"LiveDisk")==0) LiveDisk=atoi(data);
       else if (strcmp(command,"DataDisk")==0) DataDisk=atoi(data);
       else if (strcmp(command,"LiveConnectTime")==0) LiveConnectTime=atoi(data);
       else {
         char buf[200];
         sprintf(buf,"Unkown parameter %s = %s",command,data);
         MessageBox(GetActiveWindow(),buf,"Error!",MB_OK);
       }
    }
  }
  delete in;
}

CRDSetup::~CRDSetup() {}
